from osgeo import gdal
import os
#读取tif数据集
Landset_Path =r"D:\ImageData\Sen\ro3.tif"#原始图像
LabelPath = r"D:\ImageData\label\labelo1.tif"#标记样本图像
#保存txt文件
txt_Path = r"D:\save0.txt"#样本保存路径
#读取图像数据
dataset = gdal.Open(Landset_Path)
Tif_width = dataset.RasterXSize  # 栅格矩阵的列数
Tif_height = dataset.RasterYSize  # 栅格矩阵的行数
Tif_bands = dataset.RasterCount  # 波段数
Tif_geotrans = dataset.GetGeoTransform()  # 获取仿射矩阵信息
Landset_data = dataset.ReadAsArray(0, 0, Tif_width, Tif_height)
dataset = gdal.Open(LabelPath)
Label_data = dataset.ReadAsArray(0, 0, Tif_width, Tif_height)
# 写之前，先检验文件是否存在，存在就删掉
if os.path.exists(txt_Path):
    os.remove(txt_Path)
#以写的方式打开文件，如果文件不存在，就会自动创建
file_write_obj = open(txt_Path, 'w')
n=5
count=[0]*n
#收集样本
for i in range(n):
    for j in range(Label_data.shape[0]):
        for k in range(Label_data.shape[1]):

         if (Label_data[j][k] == i):
            var = ""
            count[i] = count[i] + 1
            for h in range(Landset_data.shape[0]):
               var = var + str(Landset_data[h][j][k]) + ","
            var = var + str(i)
            file_write_obj.writelines(var)
            file_write_obj.write('\n')
        else:
                continue
file_write_obj.close()